%START IDENT OTHER END
I       (0|[1-9][0-9]*)
L       [A-Z1-9]
A       [A-Z0-9]
%{
#include "stdinc.h"
#include <ctype.h>
long count0=0;
long count=0;
char mode='i';
char subdirectory[10000];
char pdb4vsi_query[10000];
char pdb0[10003][9];
char pdb[10003][9];

void	GetUniquePDB( )
{
	Int4	i,j;
	count=1;
	strncpy(pdb[count],pdb0[count],4); 
	for(i=2; i <= count0; i++){
	     for(j=1; j <= count; j++){
		if(strncmp(pdb[j],pdb0[i],4) == 0) break; // skip this one
	     }
	     if(j > count){	// did not find pdb0[i] in current list.
		count++; strncpy(pdb[count],pdb0[i],4);
	     }
	}
	// fprintf(stderr,"count=%d; count0=%d\n",count,count0);
}

%}
%%

[ ]>{I}{A}{A}{A}[_]{L}	{
				   count0++;
				   if(count0 >= 10000){
					fprintf(stderr,"Too many input pdb sequences\n"); exit(1);
				   }
				   pdb0[count0][0]=yytext[2]; pdb0[count0][1]=yytext[3];
				   pdb0[count0][2]=yytext[4]; pdb0[count0][3]=yytext[5];
				   pdb0[count0][4]=yytext[6]; pdb0[count0][5]=yytext[7];
				   pdb0[count0][6]=0;
					// printf("%c%c%c%c%c\n", yytext[4],
					//	yytext[5],yytext[6],yytext[7],yytext[9]); 
			}

^>{I}{A}{A}{A}[_]{L}	|
[\001]{I}{A}{A}{A}[_]{L}	{ 
				   count0++;
				   if(count0 >= 10000){
					fprintf(stderr,"Too many input pdb sequences\n"); exit(1);
				   }
				   pdb0[count0][0]=yytext[1]; pdb0[count0][1]=yytext[2];
				   pdb0[count0][2]=yytext[3]; pdb0[count0][3]=yytext[4];
				   pdb0[count0][4]=yytext[5]; pdb0[count0][5]=yytext[6]; 
				   pdb0[count0][6]=0;
					// printf("%c%c%c%c%c\n", yytext[4],
					//	yytext[5],yytext[6],yytext[7],yytext[9]); 
			}

pdb[|]{I}{A}{A}{A}[|]{L}	{ 
				   count0++;
				   if(count0 >= 10000){
					fprintf(stderr,"Too many input pdb sequences\n"); exit(1);
				   }
				   pdb0[count0][0]=yytext[4]; pdb0[count0][1]=yytext[5];
				   pdb0[count0][2]=yytext[6]; pdb0[count0][3]=yytext[7];
				   pdb0[count0][4]='_'; 
				   pdb0[count0][5]=yytext[9]; pdb0[count0][6]=0;
					// printf("%c%c%c%c%c\n", yytext[4],
					//	yytext[5],yytext[6],yytext[7],yytext[9]); 
				}

pdb[|]{I}{A}{A}{A}		{
				   count0++;
				   if(count0 >= 10000){
					fprintf(stderr,"Too many input pdb sequences\n"); exit(1);
				   }
				   pdb0[count0][0]=yytext[4]; pdb0[count0][1]=yytext[5];
				   pdb0[count0][2]=yytext[6]; pdb0[count0][3]=yytext[7];
				   pdb0[count0][4]=0; pdb0[count0][5]=0;
					// printf("%s\n",yytext+4); 
				}
.		{ ; }
[ \t\n]		{ ; };
%%
int yywrap()
{ 
    long i,j,f,d;
    char tmp_pdb[9];
    if(count0 > 0){
      // if(mode != 'c'){ GetUniquePDB( ); }
      switch(mode){
       case 'L': 	// ********** CE structural alignment... *********
	{
	for(i=1; i < count0; i++){ printf("%s ",pdb0[i]); }
	// printf("%s > seq_file\n\n",pdb0[count0]);
	printf("%s\n",pdb0[count0]);
	} break;
       case 'i': 	// ********** CE structural alignment... *********
	{
	printf("#!/bin/csh\n\n");
	printf("\ngetpdb ");
	for(i=1; i < count0; i++){
		printf("%s ",pdb0[i]);
	}
	// printf("%s > seq_file\n\n",pdb0[count0]);
	printf("%s \n\n",pdb0[count0]);
	} break;

      case 'm':
	{
	printf("#!/bin/csh\n\n");
#if 0
	printf("\nmgetpdb ");
#else
	printf("\nget_pdb c ");
#endif
	for(i=1; i < count0; i++){
		for(j=0; j < 4; j++) printf("%c",tolower(pdb0[i][j]));
		printf(" ");
	}
	for(j=0; j < 4; j++) printf("%c",tolower(pdb0[count0][j]));
	printf("\n\n");

#if 0
	printf("\nmreduce ");
	for(i=1; i < count0; i++){
		for(j=0; j < 4; j++) printf("%c",tolower(pdb0[i][j]));
		printf(" ");
	}
	for(j=0; j < 4; j++) printf("%c",tolower(pdb0[count0][j]));
	printf("\n\n");
#endif
        }

#if 0
	printf("\nce2cma seq_file ");
	for(i=1; i < count0; i++){
		printf("pdb");
		for(j=0; j < 4; j++) printf("%c",tolower(pdb0[i][j]));
		if(pdb0[i][4] ==0) printf(".ent:- ");
		else printf(".ent:%c ",pdb0[i][4]);
	}
	printf("pdb");
	for(j=0; j < 4; j++) printf("%c",tolower(pdb0[count0][j]));
	if(pdb0[count0][4] ==0) printf(".ent:- ");
	else printf(".ent:%c ",pdb0[count0][4]);
	printf("\n");
#endif
	break;

       case 'v': 	// *********** 'File1=' lines for .vsi file ***********
	printf("\n");
	for(f=1,d=0,i=1; i <= count0; i++){
		printf("File%d=%s/",f,subdirectory);
		for(j=0; j < 4; j++) printf("%c",tolower(pdb0[i][j]));
		if(pdb0[i][4] ==0) printf("_XH.pdb:X   // \n");
		else printf("_%cH.pdb:%c    // \n",toupper(pdb0[i][4]),toupper(pdb0[i][4]));
		if(i < count0 && strncmp(pdb0[i],pdb0[i+1],4)==0) f++;
		else { printf("\n"); d+=10; f=d+1; }
	}
	break;

       case 's': 	// ******** 'chn_pdb -S ' csh script for .vsi analysis ********
	printf("#!/bin/csh\n\n");
	for(i=1; i <= count; i++){
		printf("chn_pdb $CHN_RAS_DIR/%s/",subdirectory);
		for(j=0; j < 4; j++) printf("%c",tolower(pdb[i][j]));
		printf("_H -S ");
		printf("\n");
	} printf("\n");
	break;

       case 'd': 	// ******** make directory for 'create_vsi' files  ********
	{
	  printf("#!/bin/csh\n\n");
	  char str[10];
	  printf("mkdir x%s_DIR\n",pdb4vsi_query);
	  printf("mkdir x%s_DIR/pdb\n",pdb4vsi_query);
	  printf("\\mv -f %s* x%s_DIR/\n",pdb4vsi_query, pdb4vsi_query);
	  for(i=1; i <= count; i++){
		sprintf(str,"%c%c%c%c",tolower(pdb[i][0]),tolower(pdb[i][1]),
					tolower(pdb[i][2]),tolower(pdb[i][3]));
		printf("\\mv -f *%s* x%s_DIR/pdb/\n",str,pdb4vsi_query);
	  } printf("\n");
	} break;

       case 'p': 	// ******** pdb4vsi csh script for .vsi analysis ********
	{ 
	  char str[10];
	  printf("#!/bin/csh\n\n");
	  for(d=0,i=1; i <= count; i++,d+=10){
		sprintf(str,"%c%c%c%c",tolower(pdb[i][0]),tolower(pdb[i][1]),
					tolower(pdb[i][2]),tolower(pdb[i][3]));
		// printf("echo '************ %s_H.pdb ************'\n",str);
		printf("pdb4vsi %s $CHN_RAS_DIR/%s/",pdb4vsi_query,subdirectory);
		printf("%s_H -A%d -p=%s -subdir=%s",str,d,str,subdirectory);
		printf("\n");
	  } printf("\n");
	} break;
       default:
	print_error("mode option input error");
	break;
     }
    }
        return 1; 
}

#define USAGE "\
Usage 1: get_pdb <mode> <fasta_file>\n\
   modes: \n\
     'i' Output NCBI pdb_id command line to retrieve fasta files\n\
	  The following command line retrieves the fasta sequences\n\
	    blastdbcmd -db $FASTADIR/pdbaa -dbtype prot -entry <pdb_id>\n\
	  note: This requires formating pdbaa using the command:\n\
          makeblastdb -in $FASTADIR/pdbaa -input_type fasta -dbtype prot -parse_seqids\n\
	  The programs makeblastdb, blastdbcmd and pdbaa are available from the NCBI\n\
	    via anonymous ftp at ftp.ncbi.nlm.nih.gov.\n\
     'm' Output 'get_pdb c' command line with pdb_id arguments\n\
Usage 2: get_pdb c <pdb_id> <pdb_id> ...\n\
     'c' Retrieve pdb coordinate files correspoding to list of pdb_ids\n\
	  and then add modeled hydrogen atoms. Perl needs to be on your path\n\
          and you need to set the environmental variable 'REDUCE_PRGM' to the\n\
          reduce program (e.g., 'setenv REDUCE_PRGM reduce_3.3'),\n\
	  which is available at https://github.com/rlabduke/reduce.\n\
\n\n"

#define USAGE_FULL "\
Usage 1: get_pdb <mode> <fasta_file>\n\
   modes: \n\
     'i' Output NCBI pdb_id command line to retrieve fasta files\n\
	  The following command line retrieves the fasta sequences\n\
	    blastdbcmd -db $FASTADIR/pdbaa -dbtype prot -entry <pdb_id>\n\
	  note: This requires formating pdbaa using the command:\n\
          makeblastdb -in $FASTADIR/pdbaa -input_type fasta -dbtype prot -parse_seqids\n\
	  The programs makeblastdb, blastdbcmd and pdbaa are available from the NCBI\n\
	    via anonymous ftp at ftp.ncbi.nlm.nih.gov.\n\
     'L' Extract pdb_ids for each subunit\n\
     'm' Output 'get_pdb r' and 'mreduce' commands with pdb_id arguments\n\
Usage 2: get_pdb c <pdb_id> <pdb_id> ...\n\
     'c' Retrieve pdb coordinate files correspoding to list of pdb_ids\n\
	  and then add modeled hydrogen atoms. Perl needs to be on your path\n\
          and you need to set the environmental variable 'REDUCE_PRGM' to the\n\
          reduce program (e.g., 'setenv REDUCE_PRGM reduce_3.3'),\n\
	  which is available at https://github.com/rlabduke/reduce.\n\
Usage 3: get_pdb <mode> [options]\n\
   modes: \n\
     'd' create 'create_vsi' output file directory\n\
     'p' Output a perl script to retrieve pdb coordinate files\n\
     'v' 'File1=' lines for .vsi analysis\n\
   options:\n\
     -dir=<str>	pdb subdirectory for vsi output (default: 'ZZZ')\n\
     -query=<str>	query for pdb4vsi command (default: '1XYZ')\n\
\n\n"
 
#include "get_pdb.h"
#include "twp_typ.h"
#include "afnio.h"
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <cstdint>
// #include <filesystem>

static int RunMReduce(int argc,char *argv[],BooLean *skip)
{
	Int4	i,j;
	int	status;
	char	str[200],Str[200],*name;
	FILE *xfp,*fp;
	char *reduce=getenv("REDUCE_PRGM");
	if(reduce==0) print_error("setenv REDUCE_PRGM to the reduce program");
	char *dictionary=getenv("REDUCE_HET_DICT");
	if(dictionary==0) print_error("setenv REDUCE_HET_DICT to reduce_het_dict.txt");
	for(i=2; argv[i]; i++){
	   if(skip[i]) continue;
#if 0
	   if((-e pdb$name.ent) && (-z pdb${name}.ent)){
		\rm -f pdb${name}.ent; continue;
	   }
#endif
	   //========= see whether output files exist ===================
	   name=argv[i];
	   sprintf(str,"pdb%s.ent",name);
	   fp=fopen(str,"r");
	   if(fp == NULL) continue; else fclose(fp);
	   sprintf(str,"%s_H.pdb",name);
	   fp=fopen(str,"r");
	   if(fp != NULL){ fclose(fp); continue; }

	   //========= Run reduce with build ===================
	   sprintf(Str,"%s -BUILD pdb%s.ent -DB \"%s\" > %s_H.reduce.pdb",
			reduce,name,dictionary,name);
	   fprintf(stderr,"%d. %s\n",i,Str);
	   status=system(Str); 
	   if(status != 0){	//==== if failed; try another option ====
	        sprintf(Str,"%s pdb%s.ent -DB \"%s\" > %s_H.reduce.pdb",
			reduce,name,dictionary,name);
	   	status=system(Str); 
	   }

	   int	Argc=0;
	   char	*Argv[20];

fprintf(stderr,"DEBUG AAB.1\n");
	   //=========== chn_pdb ${name}_H.reduce -C > new.pdb =======
	   Argv[Argc]=AllocString("tweakPDB"); Argc++;
	   sprintf(str,"%s_H.reduce",name);
	   Argv[Argc]=AllocString(str); Argc++;
	   Argv[Argc]=AllocString("-C"); Argc++;
	   sprintf(str,"%s_H.reduce.pdb",name);
	   pdb_typ pdb=MakePDB(str);

	   twp_typ *twp= new twp_typ(Argc,Argv,pdb);
	   // for(j=0; j < Argc; j++) fprintf(stderr,"%s ",Argv[j]); fprintf(stderr,"\n");
	   FILE *ofp=tmpfile();
	   twp->Run(ofp); rewind(ofp); delete twp;
	   NilPDB(pdb); pdb=MakePDB(ofp); fclose(ofp); 

	   // fp=tmpfile(); PutPDBwithTER(fp,pdb); rewind(fp);
	   // NilPDB(pdb); pdb=MakePDB(fp);

	   ReLabelPDB(pdb); 
#if 1
	   ReNamePDB(name,pdb);
	   sprintf(str,"%s_H.pdb",name);
	   fp=open_file(str,"","w"); PutPDB(fp,pdb); fclose(fp);
	   sprintf(str,"%s_H.reduce.pdb",name); remove(str);
#else
	   fp=open_file("junk","","w"); PutPDB(fp,pdb); fclose(fp);
	   // fp=open_file("junkT","","w"); PutPDBwithTER(fp,pdb); fclose(fp);


fprintf(stderr,"DEBUG AAC.1\n");
	   //=========== chn_pdb ${name}_H.reduce -R > new.pdb =======
	   Argc--; free(Argv[Argc]); Argv[Argc]=AllocString("-R"); Argc++;
	   twp= new twp_typ(Argc,Argv,pdb); ofp=tmpfile();
	   twp->Run(ofp); rewind(ofp); delete twp;
	   NilPDB(pdb); pdb=MakePDB(ofp); fclose(ofp); 

fprintf(stderr,"DEBUG AAD.1\n");
	   if(pdb==0){
	       //======== chn_pdb pdb$name.ent -RR > tmp$name.ent ====
	       sprintf(str,"pdb%s.ent",name); 
	       free(Argv[1]); Argv[1] = AllocString(str);
	       Argc--; free(Argv[Argc]); Argv[Argc]=AllocString("-RR"); Argc++;
	       twp= new twp_typ(Argc,Argv); ofp=tmpfile();
	       twp->Run(ofp); rewind(ofp); delete twp;
	       NilPDB(pdb); pdb=MakePDB(ofp); fclose(ofp); 
	       sprintf(str,"tmp%s.ent",name); 
	       fp=open_file(str,"","w"); PutPDB(fp,pdb); fclose(fp);
	       NilPDB(pdb);

	       //======== reduce_3.3 -BUILD tmp$name.ent > ${name}_H.reduce.pdb ===
	       sprintf(Str,"%s -BUILD tmp%s.ent -DB \"%s\" > %s_H.reduce.pdb",
			reduce,name,dictionary,name);
	       fprintf(stderr,"%d. %s\n",i,Str);
	       status=system(Str); 
	       if(status != 0){	//==== if failed; try another option ====
	          sprintf(Str,"%s tmp%s.ent -DB \"%s\" > %s_H.reduce.pdb",
			reduce,name,dictionary,name);
	   	  status=system(Str); 
	       }
	       //===== chn_pdb ${name}_H.reduce -C > ${name}_junk.pdb =====
	       Argc--; free(Argv[Argc]); Argv[Argc]=AllocString("-C"); Argc++;
	       sprintf(str,"%s_H.reduce.pdb",name);
	       pdb=MakePDB(str); twp= new twp_typ(Argc,Argv,pdb);
	       for(j=0; j < Argc; j++) fprintf(stderr,"%s ",Argv[j]); fprintf(stderr,"\n");
	       FILE *ofp=tmpfile();
	       twp->Run(ofp); rewind(ofp); delete twp;
	       NilPDB(pdb); pdb=MakePDB(ofp); fclose(ofp); 
  
	       //========== chn_pdb ${name}_junk -R > ${name}_H.pdb ========
	       Argc--; free(Argv[Argc]); Argv[Argc]=AllocString("-R"); Argc++;
	       twp= new twp_typ(Argc,Argv,pdb); ofp=tmpfile();
	       twp->Run(ofp); rewind(ofp); delete twp;
	       NilPDB(pdb); pdb=MakePDB(ofp); fclose(ofp); 
	       if(pdb){
	         sprintf(str,"%s_H.pdb",name);
	         fp=open_file(str,"","w"); PutPDB(fp,pdb); fclose(fp);
	       } else {
		  fprintf(stderr,"problems with %s; skipping.\n",name); continue;
	       }
	       sprintf(str,"%s_H.reduce.pdb",name); remove(str);
	   } else {
	       sprintf(str,"%s_H.pdb",name);
	       fp=open_file(str,"","w"); PutPDB(fp,pdb); fclose(fp);
	       sprintf(str,"%s_H.reduce.pdb",name); remove(str);
	   }
#endif
	}
}

int	main(int argc, char *argv[]) 
{
	Int4	arg,start;
	char	str[200];
	int	status;

	if(argc < 2 || argv[1][1] != 0 || strchr("cdimLprsv",argv[1][0]) == NULL){
		print_error(USAGE);
	} else mode=argv[1][0];
	if(mode=='m' || mode=='i' || mode=='L'){
	  if(argc < 3) print_error(USAGE);
	  yyin=open_file(argv[2],"","r"); while(yylex());
	  fclose(yyin); return 0;
	} else if(mode=='p'){
	  FILE *fp=open_file(argv[0],".pl","w"); 
	  fprintf(fp,PERL_GET_PDB); fclose(fp);
	  sprintf(str,"chmod a+x %s.pl\n",argv[0]);
	  fprintf(stderr,"%s\n",str);
	  system(str);
	  return 0; 
	} else if(mode=='c'){
	  if(argc < 3) print_error(USAGE);
	  FILE *fp=open_file(argv[0],".pl","w"); 
	  fprintf(fp,PERL_GET_PDB); fclose(fp);
	  sprintf(str,"chmod a+x %s.pl\n",argv[0]);
	  fprintf(stderr,"%s\n",str);
	  system(str);
	  BooLean *skip; NEW(skip,argc + 5, BooLean);
	  for(Int4 i=2; argv[i]; i++){
	     sprintf(str,"pdb%s.ent",argv[i]);
	     fp=fopen(str,"r");
	     if(fp != NULL){ 
	     	fprintf(stderr,"\t%s file exists\n",str);
		 fclose(fp); continue; 
	     } else fprintf(stderr,"retrieving %s\n",str);
	     sprintf(str,"(./%s.pl %s > pdb%s.ent) >& /dev/null\n",
				argv[0],argv[i],argv[i]);
	     status=system(str);
	     if(status != 0){ skip[i]=TRUE; }
	  }
	  for(Int4 i=2; argv[i]; i++){
	     if(skip[i]){
		fprintf(stderr,"File pdb%s.ent is empty",argv[i]);
		fprintf(stderr,"...deleting.\n",argv[i]);
	        sprintf(str,"pdb%s.ent",argv[i]); remove(str);
	     }
	  }
	  sprintf(str,"%s.pl",argv[0]); remove(str);
	  RunMReduce(argc,argv,skip); free(skip);
	  return 0; 
	} else {
	  start = 2;
	  strcpy(subdirectory,"ZZZ");
	  strcpy(pdb4vsi_query,"1XYZ");
          for(arg = start; arg < argc; arg++){
           if(argv[arg][0] != '-') print_error(USAGE);
           switch(argv[arg][1]) {
              case 'q':
                  if(sscanf(argv[arg],"-query=%s",pdb4vsi_query) != 1) print_error(USAGE);
		  if(!isprint(pdb4vsi_query[0])) print_error(USAGE);
		break;
              case 'd':
                  if(sscanf(argv[arg],"-dir=%s",subdirectory) != 1) print_error(USAGE);
		  if(!isprint(subdirectory[0])) print_error(USAGE);
		break;
	      default: print_error(USAGE);
	   }
	  }
	  while(yylex());
	} return 0;
}


