# Neuwald lab software source code.

*** Instructions for installing and running on a local machine: ****

### Prerequisites

install CUDA, Jansson, openMP (gomp) and UUID libraries.
optionally install msgpack library.

### Installing

How to unpack...
gunzip afn_soft.tar.gz
tar xvf afn_soft.tar 

cd afn_software
mkdir build
cd build
cmake ..
make

executables will be in corresponding subdirectories:

for debugging use:
cmake -DCMAKE_BUILD_TYPE=Debug
or 
use set(CMAKE_CXX_FLAGS "-g") in CMakeLists.txt
## Author: Andrew F. Neuwald
  [University of Maryland](https://www.igs.umaryland.edu/labs/neuwald/)

## License: Freely distributed under the MIT License

## Funding

National Institutes of Health, National Institute of General Medical Sciences grants:
  R01GM078541 and R01GM125878

