#if !defined (GET_PDB_PERL)
#define GET_PDB_PERL


#define PERL_GET_PDB "\
#!/usr/bin/perl -w \n\
use strict;\n\
use Symbol;\n\
use LWP::Simple;\n\
my $acc = shift;\n\
if (!defined ($acc)) { print \"USAGE: getpdb.pl pdbid\\n\"; exit; } \n\
\n\
  my $get = \n\
\" \n\
http://www.rcsb.org/pdb/files/${acc}.pdb\n\
\";\n\
\n\
  my $page = get $get;\n\
   my $nl = \"\n\"; \n\
   my @tmp = split(/$nl/,$page); \n\
   my $start = 0; \n\
   my $list = \"\";\n\
   foreach(@tmp){ \n\
     if (/^HEADER/) {  $start=1; }\n\
     if ($start == 0){ next; }\n\
     print \"$_\n\";\n\
     if (/^END/) {  $start=0; }\n\
   } \n\
\n\n"

#endif

